#include "StdAfx.h"
#include "NDrawTree.h"


#define COLOR_NORMAL_TEXT		(RGB(34, 34, 34))		// #222222
#define COLOR_NORMAL_BK			(RGB(255, 255, 255))
/*

IMPLEMENT_DYNAMIC(CNDrawTree, CTreeCtrl)

CNDrawTree::CNDrawTree()
{
	m_pWorkStatusLayerDlg = NULL;
	m_bVScrollBarVisible=false;

	m_imgArrow[0]  = new Image(GetAppImgFile(L"New_Info_Arrow_Up.png"));
	m_imgArrow[1]  = new Image(GetAppImgFile(L"New_Info_Arrow_Down.png"));

	const BYTE nStatusCnt = 14;
	for( BYTE i = 0; i < nStatusCnt; i++ )
	{
		CString strImageFilePath = GET_APP()->GetBuddyPresenceImageFilePath( (GTUserStatusType)(i > ustMEETING ? i - (ustMEETING+1) | ustMOBILE : i));
		m_mapStatus.insert(make_pair((BYTE)i, new Image(strImageFilePath)));
	}

	const BYTE nIPTStatusCnt = 9;
	for( BYTE i = 0; i < nIPTStatusCnt; i++ )
	{
		CString strImageFilePath = GET_APP()->GetBuddyIPTPresenceImageFilePath( (NTIPTStatusType)i);
		m_mapIptStatus.insert(make_pair((NTIPTStatusType)i, new Image(strImageFilePath)));
	}
	m_pImgWorkStatus = new Image(GetAppImgFile(L"Ic_state2_01.png"));
	m_strEmptyText = TEXT("");
}

CNDrawTree::~CNDrawTree()
{
	for (int index = 0 ; index < 2; ++index)
	{
		if (NULL != m_imgArrow[index]) delete m_imgArrow[index];
	}

	map<BYTE, Image*>::const_iterator itr_presence = m_mapStatus.begin();
	for( ; itr_presence != m_mapStatus.end(); itr_presence++ )
		delete itr_presence->second;
	m_mapStatus.clear();

	map<NTIPTStatusType, Image*>::const_iterator itr_ipt = m_mapIptStatus.begin();
	for( ; itr_ipt != m_mapIptStatus.end(); itr_ipt++ )
		delete itr_ipt->second;
	m_mapIptStatus.clear();
	SAFE_DELETE(m_pImgWorkStatus);
	SAFE_DELETE(m_pWorkStatusLayerDlg);
}

BOOL CNDrawTree::ExpandAll(HTREEITEM hItem, bool bExpand)
{
	if( (hItem==NULL)||(hItem==TVI_ROOT) )
		hItem=GetChildItem(TVI_ROOT);

	while(hItem)
	{
		Expand(hItem,bExpand ? TVE_EXPAND : TVE_COLLAPSE);

		HTREEITEM hChildItem=GetChildItem(hItem);
		if(hChildItem)
		{
			ExpandAll(hChildItem,bExpand);
		}

		hItem=GetNextSiblingItem(hItem);
	}

	return TRUE;
}

BOOL CNDrawTree::DeleteCheck(HTREEITEM hItem)
{
	HTREEITEM hChildItem=GetChildItem(hItem);
	while(hChildItem)
	{
		HTREEITEM hNextChild=GetNextSiblingItem(hChildItem);
		DeleteCheck(hChildItem);
		hChildItem=hNextChild;
	}

	return CTreeCtrl::SetCheck(hItem,FALSE);
}

BOOL CNDrawTree::DeleteAllCheck()
{
	HTREEITEM hItem=GetRootItem();
	while(hItem)
	{
		HTREEITEM hNext=GetNextSiblingItem(hItem);
		DeleteCheck(hItem);
		hItem=hNext;
	}

	return TRUE;
}

BEGIN_MESSAGE_MAP(CNDrawTree, CTreeCtrl)
	ON_NOTIFY_REFLECT(NM_CUSTOMDRAW, &CNDrawTree::OnNMCustomdraw)
	ON_WM_WINDOWPOSCHANGED()
END_MESSAGE_MAP()

void CNDrawTree::PreSubclassWindow()
{
	ModifyStyle(NULL,TVS_NOHSCROLL);
	CTreeCtrl::PreSubclassWindow();
}

BOOL CNDrawTree::PreTranslateMessage(MSG* pMsg)
{
	if(pMsg->message == WM_KEYDOWN && pMsg->wParam==VK_ESCAPE)
	{

		HTREEITEM hItem=GetSelectedItem();
		if(hItem)
		{   // õ ITEM(θ ) ´.
			hItem=GetParentItem(hItem);
			if(hItem)
				GroupCollapse(hItem);
		}
		else
		{   // root item ´.
			hItem=GetRootItem();
			while(hItem)
			{
				GroupCollapse(hItem);
				hItem=GetNextSiblingItem(hItem);
			}
		}

		return TRUE;
	}

	return CTreeCtrl::PreTranslateMessage(pMsg);
}

void CNDrawTree::OnNMCustomdraw(NMHDR *pNMHDR, LRESULT *pResult)
{
	LPNMCUSTOMDRAW pNMCD = reinterpret_cast<LPNMCUSTOMDRAW>(pNMHDR);
	LPNMTVCUSTOMDRAW lpCustomDraw = reinterpret_cast<LPNMTVCUSTOMDRAW>(pNMHDR);

	*pResult =   CDRF_NOTIFYITEMDRAW ;

	if (GetCount() == 0 && !m_strEmptyText.IsEmpty()) //
	{
		//Same with IDS_STRING217("No results found" in ChatListCtrl)
		CDC dcAttach;
		dcAttach.Attach(pNMCD->hdc);

		CRect rc(0, 0, 0, 0);
		GetWindowRect(&rc);
		ScreenToClient(&rc);
		//FTLTRACE(TEXT("rcClient=[%d,%d ~ %d,%d]\n"), rc.left, rc.top, rc.right, rc.bottom);

		dcAttach.SetTextColor(COLOR_NORMAL_TEXT);
		dcAttach.SetBkMode(TRANSPARENT);
		dcAttach.FillSolidRect(&rc, COLOR_NORMAL_BK);

		CFont *pOldFont = dcAttach.SelectObject(&g_ftDefault10PT);
		rc.top += 30;
		dcAttach.DrawText(m_strEmptyText, -1, rc, DT_CENTER | DT_SINGLELINE);

		dcAttach.SelectObject(pOldFont);
		dcAttach.Detach();

		*pResult = CDRF_SKIPDEFAULT;
	}
	else
	{
		switch(pNMCD->dwDrawStage)
		{
		case CDDS_PREPAINT:
			{

			}
			break;
		case CDDS_PREERASE:
			break;
		case CDDS_POSTERASE:
			break;
		case CDDS_ITEMPREERASE:

			break;
		case CDDS_ITEMPOSTERASE:
			{

			}
			break;
		case CDDS_ITEMPREPAINT:
			{
				int i=0;
				HTREEITEM hItem=(HTREEITEM)pNMCD->dwItemSpec;
				TVITEMEX TvItemEx;
				::ZeroMemory(&TvItemEx,sizeof(TvItemEx));
				TvItemEx.hItem=hItem;
				TvItemEx.mask=TVIF_INTEGRAL|TVIF_PARAM|TVIF_STATE;
				SendMessage(TVM_GETITEM,NULL,(LPARAM)&TvItemEx);
				CDC* pDC = CDC::FromHandle(pNMCD->hdc);
				//	pDC->FillSolidRect(pNMCD->rc.left,pNMCD->rc.top,pNMCD->rc.right - pNMCD->rc.left, pNMCD->rc.bottom - pNMCD->rc.top , RGB(255,255,255));
				if(NULL != GetSafeHwnd())
					DrawItem(hItem,pDC->m_hDC,pNMCD->rc,lpCustomDraw->iLevel,&TvItemEx);
				*pResult = CDRF_SKIPDEFAULT;
			}
			break;
		case CDDS_ITEMPOSTPAINT:

			break;
		case CDDS_ITEMPREPAINT | CDDS_SUBITEM:

			break;
		case CDDS_ITEMPOSTPAINT | CDDS_SUBITEM:
			break;
		case CDDS_POSTPAINT:

			break;
		default:
			break;
		}
	}
}

void CNDrawTree::DrawItem(HTREEITEM hItem,HDC hDC,CRect rcItem,int nLevel,LPTVITEMEX lpItem)
{

}

BOOL CNDrawTree::SetCheck(HTREEITEM hItem, BOOL fCheck)
{
	HTREEITEM hCheckedItem=NULL;
	if(fCheck)
	{
		bool bFindIt=false;
		POSITION pos=m_CheckedItems.GetHeadPosition();
		while(pos)
		{
			hCheckedItem=(HTREEITEM)m_CheckedItems.GetNext(pos);
			if(hCheckedItem==hItem)
			{
				bFindIt=true;
				break;
			}
		}
		if(!bFindIt)
			m_CheckedItems.AddTail(hItem);
	}
	else
	{
		POSITION posCurrent;
		POSITION pos=m_CheckedItems.GetHeadPosition();
		while(pos)
		{
			posCurrent=pos;
			hCheckedItem=(HTREEITEM)m_CheckedItems.GetNext(pos);
			if(hCheckedItem==hItem)
			{
				m_CheckedItems.RemoveAt(posCurrent);
				break;
			}
		}
	}

	return CTreeCtrl::SetCheck(hItem,fCheck);
}

void CNDrawTree::OnWindowPosChanged(WINDOWPOS* lpwndpos)
{
	CTreeCtrl::OnWindowPosChanged(lpwndpos);

	SCROLLBARINFO ScrollBarInfo;
	::ZeroMemory(&ScrollBarInfo,sizeof(ScrollBarInfo));
	ScrollBarInfo.cbSize=sizeof(ScrollBarInfo);
	if(GetScrollBarInfo(OBJID_VSCROLL,&ScrollBarInfo))
	{
		if(ScrollBarInfo.rgstate[0] & STATE_SYSTEM_INVISIBLE)
		{
			m_bVScrollBarVisible=false;
		}
		else
		{
			if(!m_bVScrollBarVisible)
			{
				//ũѹٰ   ȭ ٽ ׷ ش.
				Invalidate(FALSE);
			}
			m_bVScrollBarVisible=true;
		}
	}
	// Invalidate(TRUE);
	

}

void CNDrawTree::DragMove(CPoint ptScreen)
{
	CRect rcClient(0, 0, 0, 0);
	GetClientRect(&rcClient);

	ScreenToClient(&ptScreen);

	CRect rcTop=rcClient;
	rcTop.bottom=rcTop.top+10;
	if(rcTop.PtInRect(ptScreen))
	{
		SendMessage(WM_VSCROLL,SB_LINEUP,0);
	}

	CRect rcBottom=rcClient;
	rcBottom.top=rcBottom.bottom-10;
	if(rcBottom.PtInRect(ptScreen))
	{
		SendMessage(WM_VSCROLL,SB_LINEDOWN,0);
	}
}

bool CNDrawTree::GetIPTBox(HTREEITEM hItem, CRect& rcBox)
{
	TVITEMEX TvItemEx;
	::ZeroMemory(&TvItemEx,sizeof(TvItemEx));

	TvItemEx.hItem=hItem;
	TvItemEx.mask=TVIF_PARAM|TVIF_STATE;
	if(!SendMessage(TVM_GETITEM,NULL,(LPARAM)&TvItemEx))
		return false;

	if(IsGroup(hItem))
		return false;

	CRect rcItem(0, 0, 0, 0);
	if(!GetItemRect(hItem,rcItem,FALSE))
		return false;
	CRect rcIPTBox(0, 0, 0, 0);


	if(m_bVScrollBarVisible)
	{
		rcIPTBox=CRect(CPoint(rcItem.right - 22, rcItem.top + 4) , CSize(rcItem.Height(),rcItem.Height()));
	}
	else
	{
		rcIPTBox=CRect(CPoint(rcItem.right - 37, rcItem.top + 4) , CSize(rcItem.Height(),rcItem.Height()));
	}
	
	rcBox = rcIPTBox;
	return true;

}

bool CNDrawTree::GetItemIconBox(HTREEITEM hItem, CRect& rcBox)
{
	TVITEMEX TvItemEx;
	::ZeroMemory(&TvItemEx,sizeof(TvItemEx));

	TvItemEx.hItem=hItem;
	TvItemEx.mask=TVIF_PARAM|TVIF_STATE;
	if(!SendMessage(TVM_GETITEM,NULL,(LPARAM)&TvItemEx))
		return false;

	if(IsGroup(hItem))
		return false;

	CRect rcItem(0, 0, 0, 0);
	if(!GetItemRect(hItem,rcItem,FALSE))
		return false;
	CRect rcWorkStatusBox(0, 0, 0, 0);


	if(m_bVScrollBarVisible)
	{
		rcWorkStatusBox=CRect(CPoint(rcItem.left + 28, rcItem.top + 4) , CSize(rcItem.Height(),rcItem.Height()));
	}
	else
	{
		rcWorkStatusBox=CRect(CPoint(rcItem.left + 28, rcItem.top + 4) , CSize(rcItem.Height(),rcItem.Height()));
	}

	rcBox = rcWorkStatusBox;
	return true;
}
bool CNDrawTree::GetWorkStatusBox( HTREEITEM hItem, CRect& rcBox )
{
	TVITEMEX TvItemEx;
	::ZeroMemory(&TvItemEx,sizeof(TvItemEx));

	TvItemEx.hItem=hItem;
	TvItemEx.mask=TVIF_PARAM|TVIF_STATE;
	if(!SendMessage(TVM_GETITEM,NULL,(LPARAM)&TvItemEx))
		return false;

	if(IsGroup(hItem))
		return false;

	CRect rcItem(0, 0, 0, 0);
	if(!GetItemRect(hItem,rcItem,FALSE))
		return false;
	CRect rcWorkStatusBox(0, 0, 0, 0);


	if(m_bVScrollBarVisible)
	{
		rcWorkStatusBox=CRect(CPoint(rcItem.right - 42, rcItem.top + 4) , CSize(rcItem.Height(),rcItem.Height()));
	}
	else
	{
		rcWorkStatusBox=CRect(CPoint(rcItem.right - 57, rcItem.top + 4) , CSize(rcItem.Height(),rcItem.Height()));
	}

	rcBox = rcWorkStatusBox;
	return true;
}



bool CNDrawTree::GetExpandedBox(HTREEITEM hItem,CRect& rcBox)
{
	TVITEMEX TvItemEx;
	::ZeroMemory(&TvItemEx,sizeof(TvItemEx));

	TvItemEx.hItem=hItem;
	TvItemEx.mask=TVIF_PARAM|TVIF_STATE;
	if(!SendMessage(TVM_GETITEM,NULL,(LPARAM)&TvItemEx))
		return false;


	if(!IsGroup(hItem))
		return false;

	CRect rcItem(0, 0, 0, 0);
	if(!GetItemRect(hItem,rcItem,FALSE))
		return false;

	CRect rcExpanedBox=CRect(CPoint(rcItem.left + 10, rcItem.top + 3),CSize(rcItem.Height(),rcItem.Height()));

	int nIndex=GetIndent();
	rcExpanedBox.OffsetRect(0*nIndex, 0);

	rcBox=rcExpanedBox;
	return true;

}
bool CNDrawTree::IsGroup( HTREEITEM hItem ) const
{
	bool bReturn = false;

	if(hItem == NULL)
	{
		return bReturn;
	}

	if (m_groupMap.find(hItem) != m_groupMap.end())
	{
		bReturn = true;
	}
	if (NULL == GetParentItem(hItem))
	{
		bReturn = true;
	}

	return bReturn;
}
bool CNDrawTree::IsGroup( std::vector<HTREEITEM> hItemVec) const
{
	bool bRet = false;

	for(std::vector<HTREEITEM>::iterator itemIterator = hItemVec.begin();
		itemIterator!=hItemVec.end();++itemIterator)
	{
		HTREEITEM hitem=*itemIterator;
		if(IsGroup(hitem))
		{
			bRet=true;
		}
	}

	return bRet;
}

bool CNDrawTree::IsGroupSort(std::vector<HTREEITEM> hItemVec) const
{
	std::vector<HTREEITEM>::const_iterator itemIterator = hItemVec.begin();
	if (itemIterator == hItemVec.end() && hItemVec.size() != 1)
		return false;

	bool bRet = false;


	HTREEITEM hitem=*itemIterator;
	if(IsGroup(hitem))
	{
		if (hItemVec.size() == 1 )
			bRet=true;
	}
	
	return bRet;
}

void CNDrawTree::GroupExpand( HTREEITEM hItem )
{
	if (hItem == NULL)
		return;
	Expand(hItem, TVE_EXPAND);
	const IGTBuddyGroup *pGroup = (const IGTBuddyGroup *)GetItemData(hItem);
	GET_CONFIG()->SetExpandBuddyGroup(pGroup->GetID());
	GET_CONFIG()->SaveExpandBuddyGroup();
}

void CNDrawTree::GroupCollapse( HTREEITEM hItem )
{
	Expand(hItem, TVE_COLLAPSE);
	const IGTBuddyGroup *pGroup = (const IGTBuddyGroup *)GetItemData(hItem);
	GET_CONFIG()->SetCollapseBuddyGroup(pGroup->GetID());
	GET_CONFIG()->SaveExpandBuddyGroup();
}

void CNDrawTree::SetEmptyText(const CString& strEmptyText)
{
	//NTALKCL-218 is spec-out, so comment these to disable show empty text,
	//if want to show empty text later, just uncomment these code

#if 0
	if (m_strEmptyText != strEmptyText)
	{
		m_strEmptyText = strEmptyText;
		Invalidate(FALSE);
	}
#endif 
}*/